<?xml version="1.0" encoding="UTF-8"?>
<con:xqueryEntry xmlns:con="http://www.bea.com/wli/sb/resources/config">
    <con:xquery><![CDATA[xquery version "1.0" encoding "Cp1252";
(:: pragma bea:global-element-parameter parameter="$req" element="ns0:GPS" location="../GenericParallelService.wsdl" ::)
(:: pragma  type="xs:anyType" ::)

declare namespace xf = "http://tempuri.org/GenericParallel/Impl/Validate/";
declare namespace ns0 = "http://genericparallel/types";
declare namespace soap-env = "http://schemas.xmlsoap.org/soap/envelope/";

declare function xf:Validate($req as element(ns0:GPS)) {
	let $gpsResult :=
		for $gpsAttr in $req/@*
		let $ln := local-name($gpsAttr)
		let $vl := data($gpsAttr)
		return
			if ( $ln = 'GPSMaxParallel' ) then (
				if( matches($vl,"^[1-9][0-9]*$") ) then ()
				else (
					<soap-env:Fault>
						<faultcode>GPS-0004</faultcode>
						<faultstring>Invalid GPSMaxParallel:{$vl}</faultstring>
						<detail>
							<GPS>
							Permitted values are positive integer, e.g. GPSMaxParallel="8"
							</GPS>
						</detail>
					</soap-env:Fault>
				) 
			) 
			else if ( $ln = 'GPSFailMode' ) then (
				if( $vl = ("NEVER","ANY_REQUEST_FAILS","ALL_REQUESTS_FAIL") ) then ()
				else (
					<soap-env:Fault>
						<faultcode>GPS-0003</faultcode>
						<faultstring>Invalid GPSFailMode:{$vl}</faultstring>
						<detail>
							<GPS>
							Permitted values are NEVER,ANY_REQUEST_FAILS,ALL_REQUESTS_FAIL
							</GPS>
						</detail>
					</soap-env:Fault>
				) 
			) 
			else if ( $ln = 'GPSDoNotSort' ) then (
				if( $vl = ("true","false") ) then ()
				else (
					<soap-env:Fault>
						<faultcode>GPS-0008</faultcode>
						<faultstring>Invalid GPSDoNotSort:{$vl}</faultstring>
						<detail>
							<GPS>
							Permitted values are true and false
							</GPS>
						</detail>
					</soap-env:Fault>
				) 
			) 
			else (
				<soap-env:Fault>
					<faultcode>GPS-0002</faultcode>
					<faultstring>Unknown GPS attribute:{$ln}</faultstring>
					<detail>
						<GPS>
						Permitted attributes are: GPSMaxParallel, GPSFailMode
						</GPS>
					</detail>
				</soap-env:Fault>
			)

	let $reqResult :=
		for $request in $req/ns0:Requests/ns0:Request
		return
			for $reqAttr in $request/@*
			let $ln := local-name($reqAttr)
			let $vl := data($reqAttr)
			return
			if ( $ln = 'GPSTargetIsProxy' ) then (
				if( $vl = ("false","true")  ) then ()
				else (
					<soap-env:Fault>
						<faultcode>GPS-0005</faultcode>
						<faultstring>Invalid GPSTargetIsProxy:{$vl}</faultstring>
						<detail>
							<GPS>
							Permitted values are true and false
							</GPS>
						</detail>
					</soap-env:Fault>
				)
			) 
			else if ( $ln = 'GPSOperation' ) then (
			)
			else if ( $ln = 'GPSTarget' ) then (
				if( matches($vl,"^[^/].*[^/]$") ) then ()
				else (
					<soap-env:Fault>
						<faultcode>GPS-0009</faultcode>
						<faultstring>Invalid GPSTarget:{$vl}</faultstring>
						<detail>
							<GPS>
							Valid values are not starting with / and do not end with / or file extension, e.g. "Project/Folder/Service"
							</GPS>
						</detail>
					</soap-env:Fault>
				) 
			) 
			else (
			)

	let $tgtResult :=
		for $request in $req/ns0:Requests/ns0:Request
		return 
			if( not($request/@GPSTarget) ) then (
				<soap-env:Fault>
					<faultcode>GPS-0007</faultcode>
					<faultstring>Missing Request attribute GPSTarget</faultstring>
					<detail>
						<GPS>
						Valid value is like GPSTarget="Project/Folder/Folder/Service"
						</GPS>
					</detail>
				</soap-env:Fault>
			) else ()

			
	return
		if( $gpsResult ) then $gpsResult
		else if( $reqResult ) then $reqResult
		else if( $tgtResult ) then $tgtResult
		else ()
};

declare variable $req as element(ns0:GPS) external;

xf:Validate($req)]]></con:xquery>
    <con:dependency location="../GenericParallelService.wsdl">
        <con:wsdl ref="GenericParallel/GenericParallelService"/>
    </con:dependency>
</con:xqueryEntry>